
import { _decorator, Component, Node, TiledMap, Prefab, TiledLayer, Vec2, Vec3, ScrollView, TiledTile } from 'cc';
const { ccclass, property } = _decorator;
import { EDITOR, JSB } from 'internal:constants';

/**
 * Predefined variables
 * Name = Test
 * DateTime = Tue Sep 28 2021 22:05:17 GMT+0800 (中国标准时间)
 * Author = liangfeijun
 * FileBasename = Test.ts
 * FileBasenameNoExtension = Test
 * URL = db://assets/script/Test.ts
 * ManualUrl = https://docs.cocos.com/creator/3.3/manual/en/
 *
 */

@ccclass('Test')
export class Test extends Component {
    _ind: number = 0;
    _lastT: number = 0;
    // [1]
    // dummy = '';

    // [2]
    // @property
    // serializableDummy = 0;

    @property(Prefab)
    userNodePrefab: Prefab = null;

    @property(TiledLayer)
    tiledLayer: TiledLayer = null;

    @property(ScrollView)
    scrollView: ScrollView = null;

    start() {
        let tl: TiledLayer = this.tiledLayer;
        for (let x = 0; x < 45; x++) {
            for (let y = 0; y < 45; y++) {
                let nd: Node = cc.instantiate(this.userNodePrefab);
                nd.position = new Vec3((x - y) * 138 * 0.5 + 45 * 138 * 0.5, -(y + x) * 70 * 0.5, 0);
                tl.addUserNode(nd);
            }
        }

        this.scrollView.scrollToOffset(new Vec2(2500, 0));
        this.onScroll(this.scrollView, 0);
    }

    onScroll(scroll: ScrollView, type: number): void {
        if (new Date().getTime() - this._lastT > 1000) {
            this._ind++;
            if (this._ind > 0) {
                this._ind = 0;
            }
            this._lastT = new Date().getTime();
        }
        let alignToScrollPos: Vec2 = new Vec2();
        //let oldPos: Vec3 = scroll.content.position;
        //let newPos: Vec3 = new Vec3(parseInt(oldPos.x), parseInt(oldPos.y), parseInt(oldPos.z));
        //scroll.content.position = newPos;

        let maps: TiledMap[] = scroll.content.getComponentsInChildren(TiledMap);
        for (let map: TiledMap of maps) {
            //     let _gl: TiledLayer = map.getLayer("Ground");
            //     for (let x = 0; x < 45; x++) {
            //         for (let y = 0; y < 45; y++) {
            //             _gl.setTileGIDAt(1 + this._ind + 1, x, y, 0);
            //         }
            //         //for (let y = 25; y < 45; y++) {
            //         //    _gl.setTileGIDAt(1 + this._ind + 1, x, y, 0);
            //         //}
            //     }

            let tls: TiledLayer[] = map.getLayers();
            for (let tl: TiledLayer of tls) {
                tl.updateCulling();
            }
        }
    }

    // update (deltaTime: number) {
    //     // [4]
    // }
}

/**
 * [1] Class member could be defined like this.
 * [2] Use `property` decorator if your want the member to be serializable.
 * [3] Your initialization goes here.
 * [4] Your update function goes here.
 *
 * Learn more about scripting: https://docs.cocos.com/creator/3.3/manual/en/scripting/
 * Learn more about CCClass: https://docs.cocos.com/creator/3.3/manual/en/scripting/ccclass.html
 * Learn more about life-cycle callbacks: https://docs.cocos.com/creator/3.3/manual/en/scripting/life-cycle-callbacks.html
 */
